package com.hzya.frame.Jackyun.goodsdocin.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.Jackyun.goodsdocin.dao.IGoodsdocInDao;
import com.hzya.frame.Jackyun.goodsdocin.dao.IGoodsdocInDetailDao;
import com.hzya.frame.Jackyun.goodsdocin.dao.IGoodsdocInLogisticDao;
import com.hzya.frame.Jackyun.goodsdocin.entity.GoodsdocInDetailEntity;
import com.hzya.frame.Jackyun.goodsdocin.entity.GoodsdocInEntity;
import com.hzya.frame.Jackyun.goodsdocin.entity.GoodsdocInLogisticEntity;
import com.hzya.frame.Jackyun.goodsdocin.service.IGoodsdocInService;

import com.hzya.frame.Jackyun.util.JackyunOpenHttpUtils;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.u8.delivery.service.IDeliveryOrderService;
import com.hzya.frame.u8.saleout.service.ISaleOutService;
import com.hzya.frame.u8.util.U8ResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

/**
 *
 * @content 吉客云入库单
 * @className: Administrator
 * @author laborer
 * @date 2025-03-27 15:33
 *
 */
@Service(value = "GoodsdocInServiceImpl")
public class GoodsdocInServiceImpl extends BaseService<GoodsdocInEntity,String> implements IGoodsdocInService {
    @Autowired
    private IGoodsdocInDao goodsdocInDao;
    @Autowired
    private IGoodsdocInDetailDao goodsdocInDetailDao;
    @Autowired
    private IGoodsdocInLogisticDao goodsdocInLogisticDao;
    @Autowired
    private IDeliveryOrderService deliveryOrderService;
    @Autowired
    private ISaleOutService saleOutService;

    @Override
    public void getJeckGoodsdocIn(JSONObject json) {
        JSONArray dataArr = new JSONArray();
        int i = 0;
        String method = "erp.storage.goodsdocin.v2";
        // 创建 Calendar 实例
        Date now = json.getDate("startTime");
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(now);

        // 向前偏移两分钟
        calendar.add(Calendar.MINUTE, -30);
        Date twoMinutesAgo = calendar.getTime();

        // 创建 Calendar 实例
        Date now1 = json.getDate("endTime");
        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(now1);

        // 向前偏移两分钟
        calendar1.add(Calendar.MINUTE, 10);
        Date twoMinutesAgo1 = calendar1.getTime();
        String startTime = DateUtil.format(twoMinutesAgo,"yyyy-MM-dd HH:mm:ss");//定时任务执行时传入的开始时间
        String endTime =  DateUtil.format(twoMinutesAgo1,"yyyy-MM-dd HH:mm:ss");//定时任务执行时传入的结束时间
        try {
            while (true){
                JSONObject main  = new JSONObject();
                main.put("pageSize","50");
                main.put("pageIndex",i++);
                String fields = "recId,goodsdocNo,billNo,inInDate,gmtCreate,inIntype,inIntypeName,flagData,flagDataName,vendCustomerCode,vendCustomerName,currencyCode,currencyRate,userName,warehouseCode,warehouseName,comment,memo,logisticName,logisticNo,companyId,companyName,logisticType,logisticCode,inInReason,sourceBillNo,channelId,channelCode,channelName,redStatus,field1,field2,field3,field4,field5,financeBillStatus,applyCompanyId,applyCompanyName,applyCompanyCode,applyDepartId,applyDepartName,departCode,applyUserId,applyUserName,InBillNo,gmtModified,companyCode,vendCustomerId,logisticList.id,logisticList.docNo,logisticList.logisticNo,logisticList.logisticCode,logisticList.logisticName,logisticList.logisticType,goodsDocDetailList.recId,goodsDocDetailList.goodsId,goodsDocDetailList.goodsNo,goodsDocDetailList.goodsName,goodsDocDetailList.skuId,goodsDocDetailList.skuName,goodsDocDetailList.skuBarcode,goodsDocDetailList.unitName,goodsDocDetailList.cuPrice,goodsDocDetailList.cuValue,goodsDocDetailList.caseNumber,goodsDocDetailList.rowRemark,goodsDocDetailList.assistUnit,goodsDocDetailList.estCost,goodsDocDetailList.estTax,goodsDocDetailList.estPrice,goodsDocDetailList.estPriceNoTax,goodsDocDetailList.estCostNoTax,goodsDocDetailList.taxRate,goodsDocDetailList.batchNo,goodsDocDetailList.serialNo,goodsDocDetailList.productionDate,goodsDocDetailList.expirationDate,goodsDocDetailList.shelfLife,goodsDocDetailList.shelfLiftUnit,goodsDocDetailList.sourceDetailId,goodsDocDetailList.transNoTaxPrice,goodsDocDetailList.transNoTaxAmount,goodsDocDetailList.transHasTaxPrice,goodsDocDetailList.transHasTaxAmount,goodsDocDetailList.transTaxAmount,goodsDocDetailList.detailField1,goodsDocDetailList.detailField2,goodsDocDetailList.detailField3,goodsDocDetailList.detailField4,goodsDocDetailList.detailField5,goodsDocDetailList.isCertified,goodsDocDetailList.registrationNumber,goodsDocDetailList.approvalDate,goodsDocDetailList.productionDepart,goodsDocDetailList.batchNumber,goodsDocDetailList.quantity,goodsDocDetailList.orderNum,goodsDocDetailList.serialSourceId,deliveryNo";
                main.put("selelctFields",fields);
                main.put("startDate", startTime);
                main.put("endDate", endTime);
                String result = JackyunOpenHttpUtils.post(method, "v1.0", main);
                if(StrUtil.isEmpty(result)){
                    throw new RuntimeException("获取吉客云入库单失败");
                }
                JSONObject resultObj = JSONObject.parseObject(result);
                String code = resultObj.getString("code");
                if("200".equals(code)){
                    JSONObject dataTitle = resultObj.getJSONObject("result");
                    JSONArray datas = dataTitle.getJSONArray("data");
                    if(datas.size()>0){
                        dataArr.addAll(datas);
                    }else {
                        break;
                    }
                }
            }
            AtomicInteger j = new AtomicInteger();
            //判断是否有数据处理到如果数组数据不为O则进行数据处理
            if(dataArr.size()>0){

                dataArr.forEach(item->{
                    j.getAndIncrement();
                    logger.info("失败数据位置====================================="+j);
                    GoodsdocInEntity goodsdocIn  = JSONObject.parseObject(JSON.toJSONString(item),GoodsdocInEntity.class);
                    //判断是否已经存在此单据，如果存在则跳过，如果不存在则新增写入
                    GoodsdocInEntity checkEntity = new GoodsdocInEntity();
                    checkEntity.setRecId(goodsdocIn.getRecId());
                    List<GoodsdocInEntity> goodsdocInEntityList = goodsdocInDao.checkBill(checkEntity);
                    if(goodsdocInEntityList.size() == 0){
                        //新增入库单数据
                        GoodsdocInEntity goodsdocInEntity =goodsdocInDao.saveGoodsdocIn(goodsdocIn);
                        //判断是否有物流数据如果有则保存
                        List<GoodsdocInLogisticEntity>goodsdocInLogisticEntityList = goodsdocIn.getLogisticList();
                        if(null != goodsdocInLogisticEntityList && goodsdocInLogisticEntityList.size()>0){
                            goodsdocInLogisticEntityList.forEach(logis->{
                                logis.setMainId(goodsdocIn.getRecId());
                                GoodsdocInLogisticEntity goodsdocInLogisticEntity = goodsdocInLogisticDao.saveLogis(logis);
                            });
                        }
                        //判断是否有商品数据如果有则保存
                        List<GoodsdocInDetailEntity> goodsdocInDetailEntityList = goodsdocIn.getGoodsDocDetailList();
                        if(null != goodsdocInDetailEntityList && goodsdocInDetailEntityList.size()>0){
                            goodsdocInDetailEntityList.forEach(details->{
                                details.setMainId(goodsdocIn.getRecId());
                                GoodsdocInDetailEntity goodsdocInDetailEntity = goodsdocInDetailDao.saveDetails(details);
                            });
                        }
                    }
                });
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void getJeckGoodsdocInBak(JSONObject requestJson) {
        GoodsdocInEntity goodsdocInEntity = new GoodsdocInEntity();
        goodsdocInEntity.setState("Y");
        //查询所有所有已经处理完成的出库单
        List<GoodsdocInEntity> goodsdocInEntityList = goodsdocInDao.getGoodsdocInList(goodsdocInEntity);
        if(CollectionUtils.isNotEmpty(goodsdocInEntityList)){
            goodsdocInEntityList.forEach(item -> {
                String recId = item.getRecId();
                if(StrUtil.isNotEmpty(recId)){
                    //查询出库单物流信息
                    GoodsdocInLogisticEntity logisEntity = new GoodsdocInLogisticEntity();
                    logisEntity.setMainId(recId);
                    List<GoodsdocInLogisticEntity> goodsdocInLogisticEntityList = goodsdocInLogisticDao.getGoodsdocInLogisticList(logisEntity);
                    if(CollectionUtils.isNotEmpty(goodsdocInLogisticEntityList)){
                        goodsdocInLogisticEntityList.forEach(logis -> {
                            //新增到备份表
                            goodsdocInLogisticDao.saveLogisBak(logis);
                            //在业务表删除数据
                            goodsdocInLogisticDao.deleteByMainId(logisEntity);
                        });
                    }
                    //查询出库单明细数据
                    GoodsdocInDetailEntity detailEntity = new GoodsdocInDetailEntity();
                    detailEntity.setMainId(recId);
                    List<GoodsdocInDetailEntity> goodsdocInDetailEntityList = goodsdocInDetailDao.getGoodsdocInDetailList(detailEntity);
                    if(CollectionUtils.isNotEmpty(goodsdocInDetailEntityList)){
                        goodsdocInDetailEntityList.forEach(details -> {
                            //新增到备份表
                            goodsdocInDetailDao.saveDetailsBak(details);
                            //在业务表删除数据
                            goodsdocInDetailDao.deleteByMainId(detailEntity);
                        });
                    }
                    //将表头数据新增到备份表
                    goodsdocInDao.saveGoodsdocInBak(item);
                    //删除业务表数据
                    goodsdocInDao.deleteByRecId(recId);
                }
            });
        }
    }

    @Override
    public void getJeckGoodsdocInToU8(JSONObject requestJson) {
        GoodsdocInEntity goodsdocInEntity = new GoodsdocInEntity();
//        goodsdocInEntity.setState("Y");
        //查询所有未处理的出库单信息
        List<GoodsdocInEntity> goodsdocInEntityList = goodsdocInDao.getGoodsdocInListAll(goodsdocInEntity);
        if (CollectionUtils.isNotEmpty(goodsdocInEntityList)){
            goodsdocInEntity.setGroupList(goodsdocInEntityList);
            //重新查询 然后进行分组
            List<GoodsdocInEntity> goodsdocInList = goodsdocInDao.getGoodsdocInListGroup(goodsdocInEntity);
            if(CollectionUtils.isNotEmpty(goodsdocInList)){
                //查询明细数据
                GoodsdocInDetailEntity detailEntity = new GoodsdocInDetailEntity();
                detailEntity.setGoodsdocInEntityList(goodsdocInEntityList);
                List<GoodsdocInDetailEntity> goodsdocInDetailEntityList = goodsdocInDetailDao.getGoodsdocInDetailListGroup(detailEntity);
                goodsdocInEntity = goodsdocInList.get(0);
                JSONObject jsonObject = bdingParm(goodsdocInEntity,goodsdocInDetailEntityList);
                //调用U8接口生成退货单
                U8ResultEntity u8ResultEntity = deliveryOrderService.addDeliveryT(jsonObject);
//                U8ResultEntity u8ResultEntity = new U8ResultEntity();
//                if(1==1){
//                    return;
//                }
                String state = "";
                if(!u8ResultEntity.issuccess()){
                    goodsdocInEntity.setState("N");
                }
                goodsdocInEntity.setU8BillCode(u8ResultEntity.getmessage());
                //开始组装U8红字销售出库单数据
                JSONObject saleOut = bdingParmOut(goodsdocInEntity,goodsdocInDetailEntityList);
                U8ResultEntity u8ResultOut =saleOutService.addSaleOutT(saleOut);
                if(!u8ResultOut.issuccess()){
                    goodsdocInEntity.setState("N");
                }else{
                    goodsdocInEntity.setState("Y");
                }
                goodsdocInEntity.setGroupList(goodsdocInEntityList);
                goodsdocInDao.updateGoodsdocIn(goodsdocInEntity);
            }
        }

    }
    /**
     *
     * @content 开始组装U8红字销售出库单数据
     * @className: Administrator
     * @author laborer
     * @date 2025-04-23 15:11
     *
     */

    private JSONObject bdingParmOut(GoodsdocInEntity goodsdocInEntity, List<GoodsdocInDetailEntity> goodsdocInDetailEntityList) {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("AccId", "005");
        jsonObject.put("billid", "123");
        JSONObject head = new JSONObject();
        head.put("cbuscode", goodsdocInEntity.getU8BillCode());//发货单号
        head.put("cdepcode", "00702");//todo 部门编码
        head.put("cmaker", "吉客云入库单自动生成");//创建人
        head.put("cbustype", "普通销售");//创建人
        head.put("crdcode", "203");//入库类别编码
        head.put("cwhcode", "04009");//仓库编码 todo 正式需要切换为04009
        head.put("ddate", DateUtil.format(new Date(),"yyyy-MM-dd"));//销售类型
        head.put("ccuscode", "99999994");//todo 正式需要切换未这个客户
        head.put("cDefine1", "多组织-红字采购入库");//
//        head.put("ccuscode", "01010918");//客户
        head.put("csource","发货单");
        jsonObject.put("head",head);
        JSONArray body = new JSONArray();
         int i = 0;
        if(CollectionUtils.isNotEmpty(goodsdocInDetailEntityList)){
            for(GoodsdocInDetailEntity item : goodsdocInDetailEntityList){
                i++;
//                if("501010323".equals(item.getGoodsNo())){
//                    continue;
//                }
                JSONObject details = new JSONObject();
                details.put("cbdlcode",goodsdocInEntity.getU8BillCode());//发货单号
                details.put("cdblrowno", i);//行号
                details.put("cinvcode", item.getGoodsNo());//存货编码
                details.put("iquantity",new BigDecimal(item.getQuantity()).subtract(new BigDecimal(item.getQuantity()).add(new BigDecimal(item.getQuantity()))));
//                details.put("iquantity", item.getQuantity());//数量
                body.add(details);
            }
        }
        jsonObject.put("body",body);
        return jsonObject;
    }

    private JSONObject bdingParm(GoodsdocInEntity goodsdocInEntity, List<GoodsdocInDetailEntity> goodsdocInDetailEntityList) {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("AccId", "005");
        jsonObject.put("billid", "123");
        JSONObject head = new JSONObject();
        head.put("brdflag", "1");//发货0，退货1
        head.put("breturnflag", "1");//发货0，退货1
        head.put("cbustype", "普通销售");//
        head.put("cdepcode", "00702");//销售部门
        head.put("cmaker", "吉客云入库单自动生成");//创建人
        head.put("cDefine1", "多组织-红字采购入库");//
        head.put("ccuscode", "99999994");//todo 正式需要切换未这个客户
//        head.put("ccuscode", "01010918");//客户
        head.put("cstcode", "11");//销售类型
        head.put("ddate", DateUtil.format(new Date(),"yyyy-MM-dd"));//创建时间
        jsonObject.put("head",head);
        JSONArray body = new JSONArray();
        if(CollectionUtils.isNotEmpty(goodsdocInDetailEntityList)){
            goodsdocInDetailEntityList.forEach(item -> {
                JSONObject details = new JSONObject();
                details.put("cwhcode","04009");//todo 正式需要切换为04009
                details.put("cinvcode",item.getGoodsNo());
                //计量单位编码需要按照名称去U8查询
                String unitName = item.getUnitName();
                if(StrUtil.isNotEmpty(unitName)){
                    details.put("cunitid",unitName);//计量单位名称 todo 业务接口需要再次查询一下
                }
                //todo idiscount原币折扣金额没有 看看是否需要调整代码
                details.put("isum",item.getTransHasTaxAmount());
                details.put("iquantity",new BigDecimal(item.getQuantity()).subtract(new BigDecimal(item.getQuantity()).add(new BigDecimal(item.getQuantity()))));
                details.put("itaxrate",item.getTaxRate());
                body.add(details);
            });
        }
        jsonObject.put("body",body);
        return jsonObject;
    }
}
