package com.hzya.frame.Jackyun.goodsdocout.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.Jackyun.goodsdocin.entity.GoodsdocInLogisticEntity;
import com.hzya.frame.Jackyun.goodsdocout.dao.IGoodsdocOutDao;
import com.hzya.frame.Jackyun.goodsdocout.dao.IGoodsdocOutDetailDao;
import com.hzya.frame.Jackyun.goodsdocout.dao.IGoodsdocOutLogisticDao;
import com.hzya.frame.Jackyun.goodsdocout.entity.GoodsdocOutDetailEntity;
import com.hzya.frame.Jackyun.goodsdocout.entity.GoodsdocOutEntity;
import com.hzya.frame.Jackyun.goodsdocout.entity.GoodsdocOutLogisticEntity;
import com.hzya.frame.Jackyun.goodsdocout.service.IGoodsdocOutService;
import com.hzya.frame.Jackyun.util.JackyunOpenHttpUtils;
import com.hzya.frame.basedao.service.impl.BaseService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 *
 * @content 吉客云出库单
 * @className: Administrator
 * @author laborer
 * @date 2025-03-27 15:33
 *
 */
@Service(value = "GoodsdocOutServiceImpl")
public class GoodsdocOutServiceImpl extends BaseService<GoodsdocOutEntity,String> implements IGoodsdocOutService {
    @Autowired
    private IGoodsdocOutDao goodsdocOutDao;
    @Autowired
    private IGoodsdocOutLogisticDao goodsdocOutLogisticDao;
    @Autowired
    private IGoodsdocOutDetailDao goodsdocOutDetailDao;
    @Override
    public void getjRckYunGoodsdocOut(JSONObject json) {
        JSONArray dataArr = new JSONArray();
        int i = 0;
        String method = "erp.storage.goodsdocout.v2";
        // 创建 Calendar 实例
        Date now = json.getDate("startTime");
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(now);

        // 向前偏移两分钟
        calendar.add(Calendar.MINUTE, -30);
        Date twoMinutesAgo = calendar.getTime();

        // 创建 Calendar 实例
        Date now1 = json.getDate("endTime");
        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(now1);

        // 向前偏移两分钟
        calendar1.add(Calendar.MINUTE, 10);
        Date twoMinutesAgo1 = calendar1.getTime();
        String startTime = DateUtil.format(twoMinutesAgo,"yyyy-MM-dd HH:mm:ss");//定时任务执行时传入的开始时间
        String endTime =  DateUtil.format(twoMinutesAgo1,"yyyy-MM-dd HH:mm:ss");//定时任务执行时传入的结束时间
        try {
            while (true){
                JSONObject main  = new JSONObject();
                main.put("pageSize","50");
                main.put("pageIndex",i++);
                String fields = "recId,goodsdocNo,billNo,inOutDate,gmtCreate,inouttype,inouttypeName,flagData,flagDataName,vendCustomerCode,vendCustomerName,currencyCode,currencyRate,userName,warehouseCode,warehouseName,comment,memo,logisticName,logisticNo,companyId,companyName,logisticType,logisticCode,inOutReason,sourceBillNo,channelId,channelCode,channelName,redStatus,field1,field2,field3,field4,field5,financeBillStatus,applyCompanyId,applyCompanyName,applyCompanyCode,applyDepartId,applyDepartName,departCode,applyUserId,applyUserName,outBillNo,gmtModified,companyCode,vendCustomerId,logisticList.id,logisticList.docNo,logisticList.logisticNo,logisticList.logisticCode,logisticList.logisticName,logisticList.logisticType,goodsDocDetailList.recId,goodsDocDetailList.goodsId,goodsDocDetailList.goodsNo,goodsDocDetailList.goodsName,goodsDocDetailList.skuId,goodsDocDetailList.skuName,goodsDocDetailList.skuBarcode,goodsDocDetailList.unitName,goodsDocDetailList.cuPrice,goodsDocDetailList.cuValue,goodsDocDetailList.caseNumber,goodsDocDetailList.rowRemark,goodsDocDetailList.assistUnit,goodsDocDetailList.estCost,goodsDocDetailList.estTax,goodsDocDetailList.estPrice,goodsDocDetailList.estPriceNoTax,goodsDocDetailList.estCostNoTax,goodsDocDetailList.taxRate,goodsDocDetailList.batchNo,goodsDocDetailList.serialNo,goodsDocDetailList.productionDate,goodsDocDetailList.expirationDate,goodsDocDetailList.shelfLife,goodsDocDetailList.shelfLiftUnit,goodsDocDetailList.sourceDetailId,goodsDocDetailList.transNoTaxPrice,goodsDocDetailList.transNoTaxAmount,goodsDocDetailList.transHasTaxPrice,goodsDocDetailList.transHasTaxAmount,goodsDocDetailList.transTaxAmount,goodsDocDetailList.detailField1,goodsDocDetailList.detailField2,goodsDocDetailList.detailField3,goodsDocDetailList.detailField4,goodsDocDetailList.detailField5,goodsDocDetailList.isCertified,goodsDocDetailList.registrationNumber,goodsDocDetailList.approvalDate,goodsDocDetailList.productionDepart,goodsDocDetailList.batchNumber,goodsDocDetailList.quantity,goodsDocDetailList.orderNum,goodsDocDetailList.serialSourceId,deliveryNo";
                main.put("selelctFields",fields);
                main.put("startDate", startTime);
                main.put("endDate", endTime);
                String result = JackyunOpenHttpUtils.post(method, "v1.0", main);
                if(StrUtil.isEmpty(result)){
                    throw new RuntimeException("获取吉客云出库单失败");
                }
                JSONObject resultObj = JSONObject.parseObject(result);
                String code = resultObj.getString("code");
                if("200".equals(code)){
                    JSONObject dataTitle = resultObj.getJSONObject("result");
                    JSONArray datas = dataTitle.getJSONArray("data");
                    if(datas.size()>0){
                        dataArr.addAll(datas);
                    }else {
                        break;
                    }
                }
            }
            //判断是否有数据处理到如果数组数据不为O则进行数据处理
            if(dataArr.size()>0){
                dataArr.forEach(item->{
                    GoodsdocOutEntity goodsdocOut  = JSONObject.parseObject(JSON.toJSONString(item),GoodsdocOutEntity.class);
                    //判断是否已经存在此单据，如果存在则跳过，如果不存在则新增写入
                    GoodsdocOutEntity checkEntity = new GoodsdocOutEntity();
                    checkEntity.setRecId(goodsdocOut.getRecId());
                    List<GoodsdocOutEntity> goodsdocOutEntityList = goodsdocOutDao.checkBill(checkEntity);
                    if(goodsdocOutEntityList.size() == 0){
                        //新增出库单数据
                        GoodsdocOutEntity goodsdocOutEntity =goodsdocOutDao.saveGoodsdocOut(goodsdocOut);
                        //判断是否有物流数据如果有则保存
                        List<GoodsdocOutLogisticEntity>goodsdocOutLogisticEntityList = goodsdocOut.getLogisticList();
                        if(null != goodsdocOutLogisticEntityList && goodsdocOutLogisticEntityList.size()>0){
                            goodsdocOutLogisticEntityList.forEach(logis->{
                                logis.setMainId(goodsdocOut.getRecId());
                                GoodsdocOutLogisticEntity goodsdocOutLogisticEntity = goodsdocOutLogisticDao.saveLogis(logis);
                            });
                        }
                        //判断是否有商品数据如果有则保存
                        List<GoodsdocOutDetailEntity> goodsdocOutDetailEntityList = goodsdocOut.getGoodsDocDetailList();
                        if(null != goodsdocOutDetailEntityList && goodsdocOutDetailEntityList.size()>0){
                            goodsdocOutDetailEntityList.forEach(details->{
                                details.setMainId(goodsdocOut.getRecId());
                                GoodsdocOutDetailEntity goodsdocOutDetailEntity = goodsdocOutDetailDao.saveDetails(details);
                            });
                        }
                    }
                });
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public void jeckYunGoodsdocOutBak(JSONObject requestJson) {
        GoodsdocOutEntity goodsdocOutEntity = new GoodsdocOutEntity();
        goodsdocOutEntity.setState("Y");
        //查询所有所有已经处理完成的出库单
        List<GoodsdocOutEntity> goodsdocOutEntityList = goodsdocOutDao.getGoodsdocOutList(goodsdocOutEntity);
        if(CollectionUtils.isNotEmpty(goodsdocOutEntityList)){
            goodsdocOutEntityList.forEach(item -> {
                String recId = item.getRecId();
                if(StrUtil.isNotEmpty(recId)){
                    //查询出库单物流信息
                    GoodsdocOutLogisticEntity logisEntity = new GoodsdocOutLogisticEntity();
                    logisEntity.setMainId(recId);
                    List<GoodsdocOutLogisticEntity> goodsdocOutLogisticEntityList = goodsdocOutLogisticDao.getGoodsdocOutLogisticList(logisEntity);
                    if(CollectionUtils.isNotEmpty(goodsdocOutLogisticEntityList)){
                        goodsdocOutLogisticEntityList.forEach(logis -> {
                            //新增到备份表
                            goodsdocOutLogisticDao.saveLogisBak(logis);
                            //在业务表删除数据
                            goodsdocOutLogisticDao.deleteByMainId(logisEntity);
                        });
                    }
                    //查询出库单明细数据
                    GoodsdocOutDetailEntity detailEntity = new GoodsdocOutDetailEntity();
                    detailEntity.setMainId(recId);
                    List<GoodsdocOutDetailEntity> goodsdocOutDetailEntityList = goodsdocOutDetailDao.getGoodsdocOutDetailList(detailEntity);
                    if(CollectionUtils.isNotEmpty(goodsdocOutDetailEntityList)){
                        goodsdocOutDetailEntityList.forEach(details -> {
                            //新增到备份表
                            goodsdocOutDetailDao.saveDetailsBak(details);
                            //在业务表删除数据
                            goodsdocOutDetailDao.deleteByMainId(detailEntity);
                        });
                    }
                    //将表头数据新增到备份表
                    goodsdocOutDao.saveGoodsdocOutBak(item);
                    //删除业务表数据
                    goodsdocOutDao.deleteByRecId(recId);
                }
            });
        }
    }
}
