package com.hzya.frame.u8.productionin.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.lang.UUID;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.u8.production.dao.IMomOrderDao;
import com.hzya.frame.u8.production.entity.MomOrderEntity;
import com.hzya.frame.u8.productionin.entity.ProductionInEntity;
import com.hzya.frame.u8.productionin.service.IProductionInService;
import com.hzya.frame.u8.saleinv.dao.ISaleInvDao;
import com.hzya.frame.u8.saleinv.entity.SaleInvEntity;
import com.hzya.frame.u8.util.BaseU8Result;
import com.hzya.frame.u8.util.U8ResultEntity;
import com.hzya.frame.u8.util.U8Util;
import org.apache.commons.collections.CollectionUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 *
 * @content 生产入库单
 * @className: Administrator
 * @author laborer
 * @date 2025-02-27 9:10
 *
 */
@Service(value = "ProductionInServicempl")
public class ProductionInServicempl extends BaseService<ProductionInEntity,String> implements IProductionInService {
    @Autowired
    private ISaleInvDao saleInvDao;
    Logger logger = LogManager.getLogger(getClass());
    /**
     *
     * @content 产成品入库-新增
     * @className: Administrator
     * @author laborer
     * @date 2025-02-24 14:33
     *
     */
    @Override
    public U8ResultEntity addProductionIn(JSONObject parm) {
        String billCode = "";
        String dlId = "";
        String AccId = "";
        JSONObject jsonObject = parm.getJSONObject("jsonStr");
        logger.info("接收到的参数"+jsonObject.toString());
        StringBuffer resultStr = new StringBuffer();//回传json
        try {
            String billid = jsonObject.getString("billid");
            if(StrUtil.isEmpty(billid)){
                return BaseU8Result.getFailureMessageEntity("请传入第三方唯一标识");
            }
            AccId = jsonObject.getString("AccId");
            if(StrUtil.isEmpty(AccId)){
                return BaseU8Result.getFailureMessageEntity("请传入正确的账套号");
            }
            String AccCode = U8Util.accMap.get(AccId);
            if(StrUtil.isEmpty(AccCode)){
                return BaseU8Result.getFailureMessageEntity("请传入正确的账套号");
            }


            JSONObject jHead = jsonObject.getJSONObject("head");
            //todo 发货单表头必输项
            String[] MustInputCode = new String[] {  "cmpocode", "ddate", "cwhcode", "cmaker"};
            String[] MustInputName = new String[] {  "生产订单号", "单据日期", "仓库编码", "制单人"};
            //根据当前单据类型 所需参数判断是否传入该参数没有传入
            for (int i = 0; i < MustInputCode.length; i++)
            {
                if (StrUtil.isEmpty(jHead.getString(MustInputCode[i]))) {
                    resultStr.append("请输入：" + MustInputCode[i] + "(" + MustInputName[i] + ")") ;
                }
            }
            //如果有错误信息，则返回错误信息
            if(StrUtil.isNotEmpty(resultStr.toString())){
                return BaseU8Result.getFailureMessageEntity(resultStr.toString());
            }
//            //单据编号暂时不需要我处理
//            if(StrUtil.isEmpty(jHead.getString("ccode"))){
//
//            }
            //默认字段
            //入库类别
            if(StrUtil.isEmpty(jHead.getString("crdcode"))){
                jHead.put("crdcode","103");
            }
            //收发标识
            if(StrUtil.isEmpty(jHead.getString("brdflag"))){
                jHead.put("brdflag","1");
            }
            //单据类型编码
            if(StrUtil.isEmpty(jHead.getString("cvouchtype"))){
                jHead.put("cvouchtype","10");
            }
            //单据日期
            if(StrUtil.isEmpty(jHead.getString("ddate"))){
                jHead.put("ddate", DateUtil.format(new Date(),"yyyy-MM-dd"));
            }
            //来源单据
            if(StrUtil.isEmpty(jHead.getString("csource"))){
                jHead.put("csource","生产订单");
            }
            //业务类型
            if(StrUtil.isEmpty(jHead.getString("cbustype"))){
                jHead.put("cbustype","成品入库");
            }
            //单据模板号
            if(StrUtil.isEmpty(jHead.getString("vt_id"))){
                jHead.put("vt_id","63");
            }
            SaleInvEntity U8Obj = new SaleInvEntity();
            U8Obj.setDataSourceCode("YONYOUU8NEW");
            //验证单号唯一
            String cdefine5 = jsonObject.getString("cdefine5");
            if(StrUtil.isNotEmpty(cdefine5)){
                String cdefine5Sql = "select cdefine5 from "+AccCode+".dbo.rdrecord10 where cdefine5 = '"+cdefine5+"'";
                List<HashMap<String, Object>> cdefine5Map = saleInvDao.getU8BillData(cdefine5Sql,U8Obj);
                if(CollectionUtils.isNotEmpty(cdefine5Map) ){
                    return BaseU8Result.getFailureMessageEntity("单号重复,请检查："+cdefine5);
                }
            }
            //生产订单id
            if(StrUtil.isEmpty(jHead.getString("iproorderid"))){


                String sql = "select MoId from "+AccCode+".dbo.mom_order where MoCode = '"+jHead.getString("cmpocode")+"'";
                List<HashMap<String, Object>> momMap = saleInvDao.getU8BillData(sql,U8Obj);
                if(CollectionUtils.isEmpty(momMap) ){
                    return BaseU8Result.getFailureMessageEntity("未找到生产订单"+jHead.getString("cmpocode"));
                }
                HashMap<String, Object> mom= momMap.get(0);
                jHead.put("iproorderid",mom.get("MoId"));
            }
            //表体
            //表体
            JSONArray body = new JSONArray();
            JSONArray jBody = jsonObject.getJSONArray("body");
            for (int i = 0; i < jBody.size(); i++) {
                JSONObject jBodyObj = jBody.getJSONObject(i);
                //todo 发货单表头必输项
                String[] MustInputCodes = new String[] {  "cinvcode", "iquantity", "cmpocode", "imoseq"};
                String[] MustInputNames = new String[] {  "产品编码", "数量", "生产订单号", "生产订单行号"};
                //根据当前单据类型 所需参数判断是否传入该参数没有传入
                for (int j = 0; j < MustInputCodes.length; j++)
                {
                    if (StrUtil.isEmpty(jHead.getString(MustInputCodes[j]))) {
                        resultStr.append("请输入：" + MustInputCodes[j] + "(" + MustInputNames[j] + ")") ;
                    }
                }
                //如果有错误信息，则返回错误信息
                if(StrUtil.isNotEmpty(resultStr.toString())){
                    return BaseU8Result.getFailureMessageEntity(resultStr.toString());
                }
                //验证必填项
                if(StrUtil.isEmpty(jBodyObj.getString("cinvcode"))){
                    resultStr.append("存货编码不能为空 行："+i+1) ;
                    //如果有错误信息，则返回错误信息
                    if(StrUtil.isNotEmpty(resultStr.toString())){
                        return BaseU8Result.getFailureMessageEntity(resultStr.toString());
                    }
                }
                //判断数量不能为空  否则下面无法计算
                if(StrUtil.isEmpty(jBodyObj.getString("iquantity"))){
                    resultStr.append("数量不能为空 行："+i+1) ;
                    //如果有错误信息，则返回错误信息
                    if(StrUtil.isNotEmpty(resultStr.toString())){
                        return BaseU8Result.getFailureMessageEntity(resultStr.toString());
                    }
                }
                if("0".equals(jBodyObj.getString("iquantity"))){
                    resultStr.append("数量不能为0 行："+i+1) ;
                    //如果有错误信息，则返回错误信息
                    if(StrUtil.isNotEmpty(resultStr.toString())){
                        return BaseU8Result.getFailureMessageEntity(resultStr.toString());
                    }
                }

                //获取辅计量单位
                String invSql = "select cInvCode,cInvName,cInvStd,Inv.cComUnitCode,cInvCCode,iChangRate,cPUComUnitCode,cSAComUnitCode,cProductUnit,cSTComUnitCode  " +
                        "from "+AccCode+".dbo.Inventory Inv " +
                        "left join "+AccCode+".dbo.ComputationUnit Com On Inv.cComUnitCode = Com.cComUnitCode where cInvCode='" + jBodyObj.getString("cinvcode")+ "'";
                List<HashMap<String, Object>> invMap = saleInvDao.getU8BillData(invSql,U8Obj);
                if(CollectionUtils.isEmpty(invMap) ){
                    return BaseU8Result.getFailureMessageEntity("ERP没有该物料"+jBodyObj.getString("cinvcode"));
                }
                HashMap<String, Object> inv= invMap.get(0);
                if(StrUtil.isNotEmpty(String.valueOf(inv.get("cSTComUnitCode")))){
                    jBodyObj.put("cassunit",inv.get("cSTComUnitCode"));
                    String sqlCassUnit = "select * from "+AccCode+".dbo.ComputationUnit where cComUnitCode='" +inv.get("cSTComUnitCode")+"'";
                    List<HashMap<String, Object>> dtUnit = saleInvDao.getU8BillData(sqlCassUnit,U8Obj);
                    if(CollectionUtils.isEmpty(dtUnit) ){
                        return BaseU8Result.getFailureMessageEntity("查询单位失败，请检查，行号："+i+1);
                    }
                    HashMap<String, Object> dtUnitObj= dtUnit.get(0);
                    jBodyObj.put("iinvexchrate",dtUnitObj.get("iChangRate"));

                    jBodyObj.put("inum",jBodyObj.getBigDecimal("iquantity").divide(new BigDecimal(String.valueOf(dtUnitObj.get("iChangRate"))),6, RoundingMode.HALF_UP));
                }
                jBodyObj.put("irowno",i+1);
                //生产订单行号 imoseq
                String momsSql = " select MoDId ,SortSeq ,OrderDId ,OrderType ,OrderCode ,OrderSeq ,SoDId ,SoType ,SoCode ,SoSeq " +
                        "from "+AccCode+".dbo.mom_order mo " +
                        "left join "+AccCode+".dbo.mom_orderdetail mos on mos.MoId  = mo.MoId " +
                        "where MoCode = '"+jBodyObj.getString("cmpocode")+"' and InvCode = '"+jBodyObj.getString("cinvcode")+"' and SortSeq = '"+jBodyObj.getString("imoseq")+"'";
                List<HashMap<String, Object>> momsMap = saleInvDao.getU8BillData(momsSql,U8Obj);
                if(CollectionUtils.isEmpty(momsMap)){
                    return BaseU8Result.getFailureMessageEntity("生产订单号："+jBodyObj.getString("cmpocode")+"，存货编码：："+jBodyObj.getString("cinvcode")+"，行号："+jBodyObj.getString("imoseq")+"，不存在");
                }
                HashMap<String, Object> momsObj= momsMap.get(0);
                //生产订单子表ID
                if(StrUtil.isEmpty(jBodyObj.getString("impoids"))){
                    jBodyObj.put("impoids",momsObj.get("MoDId"));
                }
                //生产订单行号
                if(StrUtil.isEmpty(jBodyObj.getString("imoseq"))){
                    jBodyObj.put("imoseq",momsObj.get("SortSeq"));
                }
                //订单子表id
                if(StrUtil.isEmpty(jBodyObj.getString("iorderdid"))){
                    jBodyObj.put("iorderdid",momsObj.get("OrderDId"));
                }
                //订单类型
                if(StrUtil.isEmpty(jBodyObj.getString("iordertype"))){
                    jBodyObj.put("iordertype",momsObj.get("OrderType"));
                }
                //订单号
                if(StrUtil.isEmpty(jBodyObj.getString("iordercode"))){
                    jBodyObj.put("iordercode",momsObj.get("OrderCode"));
                }
                //订单行号
                if(StrUtil.isEmpty(jBodyObj.getString("iorderseq"))){
                    jBodyObj.put("iorderseq",momsObj.get("OrderSeq"));
                }
                //销售订单子表ID
                if(StrUtil.isEmpty(jBodyObj.getString("isodid"))){
                    jBodyObj.put("isodid",momsObj.get("SoDId"));
                }
                //订单类型
                if(StrUtil.isEmpty(jBodyObj.getString("isotype"))){
                    jBodyObj.put("isotype",momsObj.get("SoType"));
                }
                //销售订单号
                if(StrUtil.isEmpty(jBodyObj.getString("csocode"))){
                    jBodyObj.put("csocode",momsObj.get("SoCode"));
                }
                //销售订单行号
                if(StrUtil.isEmpty(jBodyObj.getString("isoseq"))){
                    jBodyObj.put("isoseq",momsObj.get("SoSeq"));
                }
                //判断单价是否传输，传了则计算金额
                if(StrUtil.isNotEmpty(jBodyObj.getString("iunitcost"))){
                   if(StrUtil.isEmpty(jBodyObj.getString("iprice"))){
                       BigDecimal iquantity= jBodyObj.getBigDecimal("iquantity");
                       BigDecimal iunitcost= jBodyObj.getBigDecimal("iunitcost");
                       jBodyObj.put("iprice",iquantity.multiply(iunitcost));
                   }
                }
                body.add(jBodyObj);
            }
            JSONObject main = new JSONObject();
            main.put("head",jHead);
            main.put("billid",billid);
            main.put("AccId",AccId);
            main.put("head",jHead);
            main.put("body",body);
            main.put("domPosition",new ArrayList<>());
            logger.info("产成品入库单新增推送U8："+main.toString());
            String result = U8Util.sengBillToU8(main.toString(), "8000110018");
            logger.info("产成品入库单新增推送U8结果："+result);
            JSONObject resultObj = JSON.parseObject(result);
            boolean flag = resultObj.getBoolean("success");
            logger.info(resultObj.toString());
            if(flag){
                return BaseU8Result.getSuccessMessageEntity(resultObj.getString("message"));
            }else{
                return BaseU8Result.getFailureMessageEntity(resultObj.getString("message"));
            }
        }  catch (Exception e) {
            //如果审核失败需要调用删除接口回滚单据
            JSONObject delete = new JSONObject();
            delete.put("billid", UUID.randomUUID());
            delete.put("AccId", AccId);
            delete.put("cVoucherId", billCode);
            //删除
            String resultDelete = U8Util.sengBillToU8(delete.toString(), "8000110020");
            logger.info("新增失败："+e.getMessage());
            return BaseU8Result.getFailureMessageEntity("新增失败，请联系U8管理员");
        }
    }
}
