package com.hzya.frame.u8.saleinv.dao.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.dao.MybatisGenericDao;
import com.hzya.frame.execsql.service.IExecSqlService;
import com.hzya.frame.u8.saleinv.dao.ISaleInvDao;
import com.hzya.frame.u8.saleinv.entity.SaleInvEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;

/**
 *
 * @content 销售发票
 * @className: Administrator
 * @author laborer
 * @date 2024-10-18 9:27
 *
 */
@Repository(value = "SaleInvDaoImpl")
public class SaleInvDaoImpl extends MybatisGenericDao<SaleInvEntity,String> implements ISaleInvDao {
    @Autowired
    private IExecSqlService execSqlService;
    @DS("#entity.dataSourceCode")

    @Override
    public List<SaleInvEntity> getU8SaleInv(SaleInvEntity entity) {
        return (List<SaleInvEntity>) super.selectList("com.hzya.frame.u8.saleinv.dao.impl.SaleInvDaoImpl.entity_list_base",entity);
    }
    @DS("#entity.dataSourceCode")
    @Override
    public int updateState(SaleInvEntity entity) {
        return super.update("com.hzya.frame.u8.saleinv.dao.impl.SaleInvDaoImpl.entity_update", entity);
    }
    @DS("#entity.dataSourceCode")
    @Override
    public List<HashMap<String, Object>> getU8BillData(String str, SaleInvEntity entity)throws Exception {
        return execSqlService.execSelectSql(str, entity.getDataSourceCode());
    }
    @DS("#entity.dataSourceCode")
    @Override
    public int execUpdateSql(String str, SaleInvEntity entity) throws Exception {
        return execSqlService.execUpdateSql(str, entity.getDataSourceCode());
    }
    @DS("#entity.dataSourceCode")
    @Override
    public int execInsertSql(String str, SaleInvEntity entity) throws Exception {
        return execSqlService.execInsertSql(str, entity.getDataSourceCode());
    }
}
