package com.hzya.frame.u8.util;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.u8.dto.U8ResponseDTO;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description
 * @Author xiangerlin
 * @Date 2024/5/14 15:30
 **/
public class U8Util {
    public static Map<String,String> accMap = new  HashMap<String,String>(){
        {
            put("001","UFDATA_001_2023");
            put("002","UFDATA_002_2024");
            put("004","UFDATA_004_2023");
            put("005","UFDATA_005_2023");
            put("201","UFDATA_201_2023");
        }
    };
    static Logger logger = LogManager.getLogger(U8Util.class);

    //获取token
    public static String getToken() {
        String url = "http://127.0.0.1:51910/Api/Base/GetToken";
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("secretkey", "L1NhkDrQhtBDzTxFxPI0jxWcBzTBSPvaI5xZusRRi9ofS9d6ngxrj1erwbdjxtUT");
        logger.info("获取U8token参数:{}", jsonObject.toJSONString());
        String token = HttpRequest.post( url).body(jsonObject.toJSONString()).timeout(60000).execute().body();
        logger.info("token返回参数:{}", jsonObject.toJSONString());
        if (StrUtil.isNotEmpty(token)) {
            U8ResponseDTO u8ResponseDTO = JSONObject.parseObject(token, U8ResponseDTO.class);
            return u8ResponseDTO.getMessage();
        }
        return token;

    }
    public static String sengBillToU8(String parm, String apiCode){
        String baseUrl = "http://127.0.0.1:9999/kangarooDataCenterV3/entranceController/externalCallInterface";
        System.out.println("推送参数"+parm);
        String result = HttpRequest.post(baseUrl)
                .header("appId", "800011")//头信息，多个头信息多次调用此方法即可
                .header("apiCode", apiCode)//头信息，多个头信息多次调用此方法即可
                .header("publicKey", "ZJYAWb7lhAUTYqekPkU+uHJv1/ObJxb7dT7sD8HPRDGAgyhCe7eDIk+3zDUT+v578prj")//头信息，多个头信息多次调用此方法即可
                .header("secretKey", "fviZnLBsQUAGF8w8FSOdJi7XlIm/XAZclMxRagDLfTyJFlvnIBF3w66Hrpfzs8cYj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")//头信息，多个头信息多次调用此方法即可
                .body(parm)//表单内容
                .timeout(20000)//超时，毫秒
                .execute().body();
        System.out.println("返回参数"+result);
        if(StrUtil.isNotEmpty(result)){
            return analytic(result);
        }
        return null;
    }


    public static String analytic(String parm){
        JSONObject main = JSON.parseObject(parm);
        return main.getString("attribute");
    }
    public static JSONObject CalculationSum(BigDecimal iSum, BigDecimal iQuantity, BigDecimal nflat, BigDecimal iPerTaxRate, int iLenDecimal){
        JSONObject ae = new JSONObject();
        ae.put("iSum",iSum);
        ae.put("iQuantity",iQuantity);
        ae.put("nflat",nflat);
        ae.put("iPerTaxRate",iPerTaxRate);
        ae.put("iLenDecimal",iLenDecimal);

        ae.put("TaxPrice",iSum.divide(iQuantity,6, RoundingMode.HALF_UP));
        ae.put("Money",iSum.divide(new BigDecimal(1).add(iPerTaxRate.multiply(new BigDecimal(0.01))),6)) ;
        ae.put("UnitPrice",ae.getBigDecimal("Money").divide(iQuantity,6, RoundingMode.HALF_UP));
        ae.put("NatSum",iSum.multiply(nflat));
        ae.put("NatUnitPrice",ae.getBigDecimal("UnitPrice").multiply(nflat));
        ae.put("NatMoney",ae.getBigDecimal("Money").multiply(nflat)) ;
        ae.put("NatTaxPrice",ae.getBigDecimal("TaxPrice").multiply(nflat));
        ae.put("Sum",ae.getBigDecimal("iSum").setScale(6)) ;
        ae.put("UnitPrice",ae.getBigDecimal("UnitPrice").setScale(iLenDecimal));
        ae.put("Money",ae.getBigDecimal("Money").setScale(6));
        ae.put("NatTaxPrice",ae.getBigDecimal("NatTaxPrice").setScale(iLenDecimal)) ;
        ae.put("NatSum",ae.getBigDecimal("NatSum").setScale(6));
        ae.put("NatUnitPrice",ae.getBigDecimal("NatUnitPrice").setScale(iLenDecimal));
        ae.put("NatMoney",ae.getBigDecimal("NatMoney").setScale(6));
        ae.put("Tax",ae.getBigDecimal("Sum").subtract(ae.getBigDecimal("Money")));
        ae.put("NatTax",ae.getBigDecimal("NatSum").subtract(ae.getBigDecimal("NatMoney")));
        return ae;
    }
}
